import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:senior_platform_authentication_ui/senior_platform_authentication_ui.dart';

class HomeScreen extends StatefulWidget {
  const HomeScreen({super.key});

  @override
  State<HomeScreen> createState() => _HomeScreenState();
}

class _HomeScreenState extends State<HomeScreen> {
  User? user;
  Token? token;

  @override
  void initState() {
    super.initState();
    _syncData();
  }

  _syncData() async {
    const username = UserName();
    user = await GetStoredUserUsecase().call(username);
    token = await GetStoredTokenUsecase().call(username);

    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Bem vindo ${user?.fullName}'),
      ),
      body: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          const Center(child: Text('Home Screen')),
          const SizedBox(height: 16),
          Text('Current accessToken: ${token?.accessToken}'),
          const SizedBox(height: 16),
          ElevatedButton(
            child: const Text('logout'),
            onPressed: () async {
              final username = AuthenticationBloc().state.username ?? '';
              context
                  .read<AuthenticationBloc>()
                  .add(LogoutOfflineRequested(username: username));
            },
          ),
        ],
      ),
    );
  }
}
