part of 'reset_password_cubit.dart';

class ResetPasswordState extends Equatable {
  final NetworkStatus networkStatus;
  final String username;
  final String temporaryToken;
  final PasswordPolicySettings? passwordPolicySettings;
  final ErrorType? errorType;

  const ResetPasswordState({
    required this.networkStatus,
    required this.username,
    required this.temporaryToken,
    this.passwordPolicySettings,
    this.errorType,
  });

  factory ResetPasswordState.initial() {
    return const ResetPasswordState(
      networkStatus: NetworkStatus.idle,
      username: '',
      temporaryToken: '',
    );
  }

  ResetPasswordState copyWith({
    NetworkStatus? networkStatus,
    String? username,
    String? temporaryToken,
    PasswordPolicySettings? passwordPolicySettings,
    ErrorType? errorType,
  }) {
    return ResetPasswordState(
      networkStatus: networkStatus ?? this.networkStatus,
      username: username ?? this.username,
      temporaryToken: temporaryToken ?? this.temporaryToken,
      passwordPolicySettings:
          passwordPolicySettings ?? this.passwordPolicySettings,
      errorType: errorType,
    );
  }

  @override
  List<Object?> get props => [
        networkStatus,
        username,
        temporaryToken,
        passwordPolicySettings,
        errorType,
      ];
}
