part of 'saml_authentication_cubit.dart';

enum SAMLAuthenticationScreenStatus { onboarding, webview, loading, error }

class SAMLAuthenticationState extends Equatable {
  final SAMLAuthenticationScreenStatus status;
  final bool onboardingEnabled;

  const SAMLAuthenticationState({
    required this.status,
    required this.onboardingEnabled,
  });

  factory SAMLAuthenticationState.initial() {
    return const SAMLAuthenticationState(
      status: SAMLAuthenticationScreenStatus.onboarding,
      onboardingEnabled: true,
    );
  }

  SAMLAuthenticationState copyWith({
    SAMLAuthenticationScreenStatus? status,
    bool? onboardingEnabled,
  }) {
    return SAMLAuthenticationState(
      status: status ?? this.status,
      onboardingEnabled: onboardingEnabled ?? this.onboardingEnabled,
    );
  }

  @override
  List<Object> get props => [
        status,
        onboardingEnabled,
      ];
}
