import 'package:flutter_test/flutter_test.dart';
import 'package:senior_platform_authentication_ui/senior_platform_authentication_ui.dart';

import '../../../../../mocks/mfa_info_mock.dart';
import '../../../../../mocks/token_mock.dart';

void main() {
  group('AuthenticationEventTest', () {
    test(
        'Should event be AuthenticationEventTest when '
        'call AuthenticationStatusChanged constructor', () {
      //Arrange
      const tResponse = AuthenticationResponse(
          token: tokenMock, mfaInfo: mfaInfoUnconfiguredMock);
      const status = AuthenticationStatus.authenticated;
      //Act
      var tAuthenticationStatusChanged = const AuthenticationStatusChanged(
          authenticationResponse: tResponse, status);

      //Assert
      expect(
        tAuthenticationStatusChanged,
        isA<AuthenticationEvent>(),
      );

      expect(
        tAuthenticationStatusChanged,
        const AuthenticationStatusChanged(
            authenticationResponse: tResponse, status),
      );
    });

    test(
        'Should event be AuthenticationEventTest when '
        'call LogoutOnlineRequested constructor', () {
      //Act
      var tLogoutOnlineRequested = const LogoutOnlineRequested();

      //Assert
      expect(
        tLogoutOnlineRequested,
        isA<AuthenticationEvent>(),
      );

      expect(
        tLogoutOnlineRequested,
        const LogoutOnlineRequested(),
      );
    });

    test(
        'Should event be AuthenticationEventTest when '
        'call CheckAuthenticationRequested constructor', () {
      //Arrange
      const tUsername = 'teste@senior.com.br';

      //Act
      var tLogoutOnlineRequested =
          const CheckAuthenticationRequested(username: tUsername);

      //Assert
      expect(
        tLogoutOnlineRequested,
        isA<AuthenticationEvent>(),
      );

      expect(
        tLogoutOnlineRequested,
        const CheckAuthenticationRequested(username: tUsername),
      );
    });

    test(
        'Should event be AuthenticationEventTest when '
        'call LogoutOfflineRequested constructor', () {
      //Arrange
      const tUsername = 'teste@senior.com.br';

      //Act
      var tLogoutOfflineRequested =
          const LogoutOfflineRequested(username: tUsername);

      //Assert
      expect(
        tLogoutOfflineRequested,
        isA<AuthenticationEvent>(),
      );

      expect(
        tLogoutOfflineRequested,
        const LogoutOfflineRequested(username: tUsername),
      );
    });
  });
}
